Bug 141477 - Support ::marker pseudo-element
Summary: Support ::marker pseudo-element
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: CSS (show other bugs)
Version: WebKit Nightly Build
Hardware: All All
: P2 Minor
Assignee: Daniel Bates
URL: https://www.w3.org/TR/css-lists-3/#ma...
Keywords: InRadar, WebExposed
Depends on:
Blocks:
 
Reported: 2015-02-11 10:02 PST by Kyli
Modified: 2017-08-03 09:17 PDT (History)
10 users (show)

See Also:


Attachments
Work-in-progress patch (23.55 KB, patch)
2017-07-25 17:10 PDT, Daniel Bates
no flags Details | Formatted Diff | Diff
Patch and layout tests (without compile-time guard) (28.68 KB, patch)
2017-07-26 13:55 PDT, Daniel Bates
no flags Details | Formatted Diff | Diff
Patch and layout tests (without compile-time guard) (28.71 KB, patch)
2017-07-26 13:58 PDT, Daniel Bates
no flags Details | Formatted Diff | Diff
Patch and layout tests (with compile-time guard) (73.43 KB, patch)
2017-07-26 13:59 PDT, Daniel Bates
no flags Details | Formatted Diff | Diff
Patch and layout tests (with compile-time guard) (80.56 KB, patch)
2017-07-26 14:16 PDT, Daniel Bates
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from ews101 for mac-elcapitan (1.14 MB, application/zip)
2017-07-26 15:36 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews105 for mac-elcapitan-wk2 (1.27 MB, application/zip)
2017-07-26 15:42 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews114 for mac-elcapitan (1.76 MB, application/zip)
2017-07-26 15:53 PDT, Build Bot
no flags Details
Patch and layout tests (without compile-time guard) (24.12 KB, patch)
2017-07-31 10:07 PDT, Daniel Bates
buildbot: commit-queue-
Details | Formatted Diff | Diff
Patch and layout tests (with compile-time guard) (81.74 KB, patch)
2017-07-31 10:19 PDT, Daniel Bates
no flags Details | Formatted Diff | Diff
Patch and layout tests (with compile-time guard) (81.12 KB, patch)
2017-07-31 10:20 PDT, Daniel Bates
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from ews101 for mac-elcapitan (986.75 KB, application/zip)
2017-07-31 11:18 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews105 for mac-elcapitan-wk2 (1.35 MB, application/zip)
2017-07-31 11:23 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews117 for mac-elcapitan (1.77 MB, application/zip)
2017-07-31 11:39 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews121 for ios-simulator-wk2 (983.90 KB, application/zip)
2017-07-31 11:47 PDT, Build Bot
no flags Details
Patch and layout tests (without compile-time guard) (29.18 KB, patch)
2017-07-31 14:05 PDT, Daniel Bates
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Kyli 2015-02-11 10:02:30 PST
URLs: http://stackoverflow.com/q/76564/453435, http://www.w3.org/TR/css3-lists/#marker-pseudo-element

Steps to reproduce the problem:
1. Create a webpage with bulleted lists. Do not use any stylesheets that remove the markers from lists.
2. Create a CSS stylesheet that specifies, using the ::marker pseudo-element, how these markers should look/behave, as specified by the W3C CSS3 Working Draft.

Expected result:
Markers are modified as specified.


Actual result:
Markers remain unmodified.
Comment 1 Steven Vachon 2017-02-21 07:37:11 PST
Do it.
Comment 2 Daniel Bates 2017-07-25 17:10:50 PDT
Created attachment 316407 [details]
Work-in-progress patch

Work-in-progress patch. The CSS Lists Module Level 3 is still in flux with regards to extended capabilities for ::marker. It does define and refer to CSS Pseudo-Elements Module Level 4 with reagrds to an initial definition for ::marker. I implemented this initial definition. I did not guard ::marker behind a runtime/compile-time flag. I will look into that shortly.
Comment 3 Daniel Bates 2017-07-25 17:11:25 PDT
One issue I ran into when writing the included test, http/wpt/css/css-pseudo-4/marker-font-properties.html, is that the baseline position of a marker with a font-size differs from the baseline position of a list item with the same font-size (why?). For now, I added a dummy <span> in http/wpt/css/css-pseudo-4/marker-font-properties.html so that the result will match the expected rendering of http/wpt/css/css-pseudo-4/marker-font-properties-expected.html.

I plan to submit all the included tests in http/wpt/css/css-pseudo-4 to the Web Platform Tests repository either before or after this patch is landed. If it is before this patch lands then I will update this patch to import the submitted Web Platform Tests. Otherwise, I will do this in a follow up bug.
Comment 4 Daniel Bates 2017-07-26 13:55:32 PDT
Created attachment 316473 [details]
Patch and layout tests (without compile-time guard)
Comment 5 Daniel Bates 2017-07-26 13:58:07 PDT
Created attachment 316475 [details]
Patch and layout tests (without compile-time guard)
Comment 6 Daniel Bates 2017-07-26 13:59:17 PDT
Created attachment 316476 [details]
Patch and layout tests (with compile-time guard)
Comment 7 Build Bot 2017-07-26 14:01:45 PDT Comment hidden (obsolete)
Comment 8 Daniel Bates 2017-07-26 14:16:25 PDT
Created attachment 316479 [details]
Patch and layout tests (with compile-time guard)
Comment 9 Build Bot 2017-07-26 15:36:08 PDT Comment hidden (obsolete)
Comment 10 Build Bot 2017-07-26 15:36:10 PDT Comment hidden (obsolete)
Comment 11 Build Bot 2017-07-26 15:42:13 PDT Comment hidden (obsolete)
Comment 12 Build Bot 2017-07-26 15:42:15 PDT Comment hidden (obsolete)
Comment 13 Build Bot 2017-07-26 15:53:50 PDT Comment hidden (obsolete)
Comment 14 Build Bot 2017-07-26 15:53:54 PDT Comment hidden (obsolete)
Comment 15 Daniel Bates 2017-07-31 10:07:29 PDT
Created attachment 316786 [details]
Patch and layout tests (without compile-time guard)
Comment 16 Daniel Bates 2017-07-31 10:19:06 PDT
Created attachment 316787 [details]
Patch and layout tests (with compile-time guard)
Comment 17 Daniel Bates 2017-07-31 10:20:18 PDT
Created attachment 316788 [details]
Patch and layout tests (with compile-time guard)
Comment 18 Build Bot 2017-07-31 11:18:31 PDT Comment hidden (obsolete)
Comment 19 Build Bot 2017-07-31 11:18:33 PDT Comment hidden (obsolete)
Comment 20 Build Bot 2017-07-31 11:23:16 PDT Comment hidden (obsolete)
Comment 21 Build Bot 2017-07-31 11:23:18 PDT Comment hidden (obsolete)
Comment 22 Build Bot 2017-07-31 11:39:26 PDT Comment hidden (obsolete)
Comment 23 Build Bot 2017-07-31 11:39:28 PDT Comment hidden (obsolete)
Comment 24 Build Bot 2017-07-31 11:47:46 PDT Comment hidden (obsolete)
Comment 25 Build Bot 2017-07-31 11:47:47 PDT Comment hidden (obsolete)
Comment 26 Daniel Bates 2017-07-31 14:05:39 PDT
Created attachment 316800 [details]
Patch and layout tests (without compile-time guard)
Comment 27 Dave Hyatt 2017-08-02 11:52:26 PDT
Comment on attachment 316800 [details]
Patch and layout tests (without compile-time guard)

r=me
Comment 28 Daniel Bates 2017-08-03 09:16:55 PDT
Comment on attachment 316800 [details]
Patch and layout tests (without compile-time guard)

Clearing flags on attachment: 316800

Committed r220207: <http://trac.webkit.org/changeset/220207>
Comment 29 Daniel Bates 2017-08-03 09:16:57 PDT
All reviewed patches have been landed.  Closing bug.
Comment 30 Radar WebKit Bug Importer 2017-08-03 09:17:58 PDT
<rdar://problem/33701307>